import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
import React, { useCallback } from 'react';
import PropTypes from 'prop-types';
import SafeAnchor from '../SafeAnchor';
import Ripple from '../Ripple';
import { useClassNames, createChainedFunction } from '../utils';
var defaultProps = {
  classPrefix: 'pagination-btn',
  as: SafeAnchor
};
var PaginationButton = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var Component = props.as,
      active = props.active,
      disabled = props.disabled,
      className = props.className,
      classPrefix = props.classPrefix,
      children = props.children,
      eventKey = props.eventKey,
      style = props.style,
      onSelect = props.onSelect,
      onClick = props.onClick,
      rest = _objectWithoutPropertiesLoose(props, ["as", "active", "disabled", "className", "classPrefix", "children", "eventKey", "style", "onSelect", "onClick"]);

  var _useClassNames = useClassNames(classPrefix),
      merge = _useClassNames.merge,
      withClassPrefix = _useClassNames.withClassPrefix;

  var classes = merge(className, withClassPrefix({
    active: active,
    disabled: disabled
  }));
  var handleClick = useCallback(function (event) {
    if (disabled) {
      return;
    }

    onSelect === null || onSelect === void 0 ? void 0 : onSelect(eventKey, event);
  }, [disabled, eventKey, onSelect]);
  return /*#__PURE__*/React.createElement(Component, _extends({}, rest, {
    disabled: disabled,
    onClick: createChainedFunction(onClick, handleClick),
    active: Component !== SafeAnchor && typeof Component !== 'string' ? active : undefined,
    ref: ref,
    className: classes,
    style: style
  }), children, !disabled ? /*#__PURE__*/React.createElement(Ripple, null) : null);
});
PaginationButton.displayName = 'PaginationButton';
PaginationButton.defaultProps = defaultProps;
PaginationButton.propTypes = {
  classPrefix: PropTypes.string,
  eventKey: PropTypes.any,
  onSelect: PropTypes.func,
  onClick: PropTypes.func,
  disabled: PropTypes.bool,
  active: PropTypes.bool,
  className: PropTypes.string,
  as: PropTypes.elementType,
  children: PropTypes.node,
  style: PropTypes.object,
  renderItem: PropTypes.func
};
export default PaginationButton;